GetRowPixels4 proc pRowOffset:dword,row:dword,rowstart:dword,colstart:dword,colend:dword
	LOCAL col:dword
	LOCAL b:dword
	LOCAL pixel:dword
	LOCAL multiplier:dword
	LOCAL bsbCol:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov esi,pRowOffset ;From bsb jumptable
	
	mov col,0
	;Row numbers. First and eventually second bytes
	xor ecx,ecx
@@:	and ecx,7Fh
	shl ecx,7
	push ecx
	movzx eax,byte ptr [esi]
	inc esi					
	pop ecx
	add ecx,eax
	cmp eax,80h
	jae	@B
	
	;Memory for bmp pixel data to write
	;Write from bottom to up
	mov edi,pPixelData
	mov eax,PixH ;FrameRectangle.bottom ;bsbH
	dec eax
	mov ecx,PixW ;FrameRectangle.right ;bsbW
	add ecx,padding
	mul ecx
	add edi,eax
	
	mov eax,row
	sub eax,rowstart
	mov ecx,PixW ;FrameRectangle.right ;bsbW
	add ecx,padding
	mul ecx
	sub edi,eax
	
@Scanrow:	
	movzx eax,byte ptr [esi]
	inc esi
	mov b,eax
	
	or eax,eax
	je @EndOfRow
	
	mov ecx,7
	mov eax,ColorDepth
	sub ecx,eax
	
	;Retrieve pixel value
	mov eax,b
	and eax,7Fh
	shr eax,cl
	dec eax
	mov pixel,eax
	
	;Calculate how many times the same pixel value should be painted
	mov ecx,ColorDepth
	movzx ecx,byte ptr mul_mask[ecx]
	mov eax,b
	and eax,ecx
	.while b>=80h
		shl eax,7
		push eax
		movzx eax,byte ptr [esi]
		inc esi
		pop ecx
		mov b,eax
		and eax,7Fh
		add eax,ecx
	.endw
	inc eax
	.if eax>bsbW
		mov eax,bsbW
	.endif
	mov multiplier,eax
	
	;Start of storing pixel values
	xor ecx,ecx
	.while ecx<multiplier
		push ecx
		
		mov eax,col
		.if eax<bsbW
			.if eax>colstart
				mov ecx,pixel
				mov byte ptr [edi],cl
				inc edi
			.endif
		.endif
		inc col
		inc bsbCol
		
		mov eax,colend
		.if col==eax
			add esp,4
			jmp @Skiprow
		.endif
		
		pop ecx
		inc ecx
	.endw
	mov eax,col
	cmp eax,bsbW
	jle @Scanrow
	jmp @Skiprow
	
@EndOfRow:
	;If end of row less than image width
	mov eax,bsbW 
	.if col<eax
		sub eax,col
		.if eax<8
			xor ecx,ecx
			.while ecx<eax
				push ecx
				push eax

				.if ecx<bsbW
					mov ecx,pixel
					mov byte ptr [edi],cl
					inc edi
					inc col
				.endif
				
				inc bsbCol
				pop eax
				pop ecx
				inc ecx
			.endw
		.endif
	.endif
	
@Skiprow:	
	xor ecx,ecx
	.while ecx<padding
		mov byte ptr [edi],0
		inc edi
		inc ecx
	.endw
	
	mov eax,esi ;pointer to next read address
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

GetRowPixels4 endp

