MainDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL w:dword
	LOCAL h:dword
	LOCAL pt:POINT
    LOCAL ptChart:POINT
    LOCAL ofn:OPENFILENAME
	LOCAL Long:real8

	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push hWin
		pop hMain
		invoke MoveWindow,hWin,0,0,1100,800,TRUE
		invoke SetWindowText,hMain,offset szAppName

		invoke GetDlgItem,hWin,IDC_CHART
		mov hCHART,eax
		invoke GetDlgItem,hWin,IDC_STC25
		mov hFrame,eax
		invoke SetParent,hCHART,hFrame
		
		;Subclass chart window
		invoke SetWindowLong,hCHART,GWL_WNDPROC,offset ChartProc
		mov OldChartProc,eax
		
		mov mapview,IDM_NAVVIEW
		mov xPos,0 ;Get from registry
		mov yPos,0 ;Get from registry
		invoke SetWindowPos,hCHART,HWND_NOTOPMOST,xPos,yPos,0,0,SWP_NOSIZE or SWP_NOZORDER
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==1003
				mov ofn.lStructSize,sizeof ofn
				push hWin
				pop ofn.hWndOwner
				push hInstance
				pop ofn.hInstance
				mov ofn.lpstrFile,offset szFileName
				mov ofn.nMaxFile,256
				mov ofn.lpstrFilter,offset szFilterKAP
				mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER
				invoke GetOpenFileName,addr ofn
				.if eax!=0
					invoke ComputeChartFile
				.endif
			.endif
		.endif
			
	.elseif eax==WM_LBUTTONDOWN
		invoke IsWindowVisible,hCHART
		.if eax
			invoke ClientToScreen,hCHART,addr ptChart
			invoke ScreenToClient,hFrame,addr ptChart
			mov eax,lParam
			and eax,0FFFFh
			sub eax,ptChart.x
			mov x,eax
			mov eax,lParam
			shr eax,16
			sub eax,ptChart.y
			mov y,eax
			
			mov eax,FALSE
			jmp @Exit
		.endif
		
	.elseif eax==WM_MOUSEMOVE
		invoke IsWindowVisible,hCHART
		.if eax
			mov eax,lParam
			shr eax,16
			.if eax<=25
				jmp @Exit
			.endif
			
			invoke GetCursorPos,addr pt
			invoke ScreenToClient,hCHART,addr pt
			
			;Move chart
			.if wParam==MK_LBUTTON ;&& mapview==IDM_NAVVIEW
				mov eax,lParam
				and eax,0FFFFh
				sub eax,x
				mov ecx,lParam
				shr ecx,16
				sub ecx,y
				mov edx,FrameRectangle.right ;rect.right
				sub edx,imageW
				.if sdword ptr eax>0 || sdword ptr edx>0
					mov eax,0
				.elseif sdword ptr eax<sdword ptr edx
					mov eax,edx
				.endif
				mov edx,FrameRectangle.bottom ;rect.bottom
				sub edx,imageH
				.if sdword ptr ecx>0 || sdword ptr edx>0
					mov ecx,0
				.elseif sdword ptr ecx<sdword ptr edx
					mov ecx,edx
				.endif
@@:				
				mov xPos,sdword ptr eax
				mov yPos,sdword ptr ecx
				invoke MoveWindow,hCHART,xPos,yPos,imageW,imageH,FALSE
				invoke RedrawWindow,hCHART,0,0,RDW_INVALIDATE
				invoke RedrawWindow,hWin,0,0,RDW_INVALIDATE
				
				mov eax,FALSE
				jmp @Exit
			.endif
		.endif
		
	.elseif eax==WM_LBUTTONUP
		mov x,0
		mov y,0
		invoke bsbChart4
		
	.elseif eax==WM_CLOSE
		.if pBMI!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pBMI
			mov pBMI,0
		.endif
		.if pPixelData!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pPixelData
			mov pPixelData,0
		.endif
		.if pREF!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pREF
			mov pREF,0
		.endif
		.if pPLY!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pPLY
			mov pPLY,0
		.endif
		.if pCHARTDATA!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pCHARTDATA
			mov pCHARTDATA,0
		.endif
		.if pMemory!=0
			invoke UnmapViewOfFile,pMemory
			mov pMemory,0
		.endif
		
		invoke ReleaseDC,hCHART,hDC
		invoke ReleaseDC,hCHART,hCDC
		invoke HeapDestroy,hHeap
		
		invoke EndDialog,hWin,0
		
	.elseif eax==WM_SIZE
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh ;new width
		mov w,eax
		shr edx,16 ;new height
		mov h,edx
		invoke MoveWindow,hFrame,0,25,w,h,FALSE
		
		invoke ClientToScreen,hCHART,addr pt
		invoke ScreenToClient,hFrame,addr pt
		invoke GetClientRect,hFrame,offset FrameRectangle
		mov eax,FrameRectangle.right
		mov edx,pt.x
		.if eax<imageW && sdword ptr edx<0
			sub eax,edx
			.if eax>imageW
				mov eax,FrameRectangle.right
				sub eax,imageW
				mov pt.x,eax
			.endif
		.endif
		mov eax,FrameRectangle.bottom
		mov edx,pt.y
		.if eax<imageH && sdword ptr edx<0
			sub eax,edx
			.if eax>imageH
				mov eax,FrameRectangle.bottom
				sub eax,imageH
				mov pt.y,eax
			.endif
		.endif
		
	.else
		mov eax,FALSE
		jmp @Exit
	.endif
	mov eax,TRUE

@Exit:	
	pop edx
	pop edi
	pop esi
	
	ret

MainDlgProc endp

ChartProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
   
	push esi
	push edi
	push edx
		
	.if uMsg==WM_PAINT
		;Draw chart
		mov eax,pPixelData
		mov eax,dword ptr [eax]
		.if eax!=0
			mov eax,xPos
			neg eax
			mov ecx,yPos
			neg ecx
			invoke BitBlt,hDC,ColStart,RowStart,PixW,PixH,hCDC,0,0,SRCCOPY
			invoke GdiFlush		
			
		.endif
		
		invoke CallWindowProc,OldChartProc,hWin,uMsg,wParam,lParam
		jmp @Exit
	
	.else
		invoke CallWindowProc,OldChartProc,hWin,uMsg,wParam,lParam
		jmp @Exit
	.endif
	xor eax,eax

@Exit:	
	pop edx
	pop edi
	pop esi
	
	ret
	
ChartProc endp

