REF struct
	index				dd ?
	left				dd ?
	top					dd ?
	lat					real8 ?
	long				real8 ?
REF ends

PLY struct
	utm_x				dd ? ;meters east-west
	utm_y				dd ? ;meters north-south
PLY ends

CHARTDATA struct
	index				dd ?
	chartgroup			dd ?
	scale				dd ?
	noPlys				dd ?
	chartname			db 256 dup (?)
	fullfilepath		db 256 dup (?)
CHARTDATA ends

FILE struct dword
    _ptr				dd ?
    _cnt				dd ?
    _base				dd ?
    _flag				dd ?
    _file				dd ?
    _charbuf			dd ?
    _bufsiz				dd ?
    _tmpfname			dd ?
FILE ends

BSBImage struct dword
	pFile				dd ?
	depth				db ? 
	num_colors			db ?
	_version			real4 ?
	_width				dd ?
	_height				dd ?
	xresolution			real8 ?
	yresolution			real8 ?
	red					db 256 DUP (?)
	green				db 256 DUP (?)
	blue				db 256 DUP (?)
BSBImage ends

VARIANT struct dword ;size 10h
    vt              	word ? ; VT_EMPTY
    wReserved1      	word ? ;0
    wReserved2      	word ? ;0
    wReserved3      	word ? ;0
    Union
		lVal         	sdword ?	; VT_I4					A 4-byte integer value is stored in lVal.
		bVal         	byte ?  	; VT_UI1				An unsigned 1-byte character is stored in bVal.
		iVal         	sword ? 	; VT_I2					A 2-byte integer value is stored in iVal.
		fltVal       	real4 ? 	; VT_R4					An IEEE 4-byte real value is stored in fltVal.
		dblVal       	real8 ? 	; VT_R8					An 8-byte IEEE real value is stored in dblVal.
		boolVal      	word ?  	; VT_BOOL
		scode        	dword ? 	; VT_ERROR
		cyVal        	qword ? 	; VT_CY					A currency value was specified. A currency number is stored as 64-bit (8-byte), two's complement integer, scaled by 10,000 to give a fixed-point number with 15 digits to the left of the decimal point and 4 digits to the right. The value is in cyVal.
		date         	qword ? 	; VT_DATE				A value denoting a date and time was specified. Dates are represented as double-precision numbers, where midnight, January 1, 1900 is 2.0, January 2, 1900 is 3.0, and so on. The value is passed in date.
															;This is the same numbering system used by most 
															;spreadsheet programs, although some specify 
															;incorrectly that February 29, 1900 existed, and 
															;thus set January 1, 1900 to 1.0. The date can be 
															;converted to and from an MS-DOS representation 
															;using VariantTimeToDosDateTime, which is discussed 
															;in Conversion and Manipulation Functions. 
		bstrVal      	dword ? 	; VT_BSTR				A string was passed; it is stored in bstrVal. This pointer must be obtained and freed by the BSTR functions, which are described in Conversion and Manipulation Functions. 
		punkVal      	dword ? 	; VT_UNKNOWN			A pointer to an object that implements the IUnknown interface is passed in punkVal.
		pdispVal     	dword ? 	; VT_DISPATCH			A pointer to an object was specified. The pointer is in pdispVal. This object is known only to implement IDispatch. The object can be queried as to whether it supports any other desired interface by calling QueryInterface on the object. Objects that do not implement IDispatch should be passed using VT_UNKNOWN.
		parray       	dword ? 	; VT_ARRAY				For VT_ARRAY | any type, the rule is analogous to the rule for VT_BSTR. All arrays in variants must be allocated with SafeArrayCreate. When releasing or changing the type of a variant with the VT_ARRAY flag set, SafeArrayDestroy is called.
		pbVal        	dword ? 	; VT_BYREF+VT_UI1		For VT_BYREF | any type, the memory pointed to by the variant is owned and freed by the caller of the function.
		piVal        	dword ? 	; VT_BYREF+VT_I2
		plVal        	dword ? 	; VT_BYREF+VT_I4
		pfltVal      	dword ? 	; VT_BYREF+VT_R4
		pdblVal      	dword ? 	; VT_BYREF+VT_R8
		pboolVal     	dword ? 	; VT_BYREF+VT_BOOL
		pscode       	dword ? 	; VT_BYREF+VT_ERROR
		pcyVal       	dword ? 	; VT_BYREF+VT_CY
		pdate        	dword ? 	; VT_BYREF+VT_DATE
		pbstrVal     	dword ? 	; VT_BYREF+VT_BSTR
		ppunkVal     	dword ? 	; VT_BYREF+VT_UNKNOWN
		ppdispVal    	dword ? 	; VT_BYREF+VT_DISPATCH
		pparray      	dword ? 	; VT_BYREF+VT_ARRAY
		pvarVal      	dword ? 	; VT_BYREF+VT_VARIANT
		byref        	dword ? 	; VT_BYREF
		cVal         	sbyte ? 	; VT_I1					A 1-byte character value is stored in cVal.
		uiVal        	word ?  	; VT_UI2 				An unsigned 2-byte integer value is stored in uiVal.
		ulVal        	dword ? 	; VT_UI4 				An unsigned 4-byte integer value is stored in ulVal.
		intVal       	sword ? 	; VT_INT				An integer value is stored in intVal.
		uintVal      	word ?  	; VT_UINT				An unsigned integer value is stored in uintVal.
		pdecVal      	dword ? 	; VT_BYREF+VT_DECIMAL
		pcVal        	dword ? 	; VT_BYREF+VT_I1
		puiVal       	dword ? 	; VT_BYREF+VT_UI2
		pulVal       	dword ? 	; VT_BYREF+VT_UI4
		pintVal      	dword ?		; VT_BYREF+VT_int
		puintVal     	dword ?		; VT_BYREF|VT_uint
    ends
VARIANT ends	

LANGANDCODEPAGE struct 
	wLanguage	word ? 
	wCodepage	word ? 
LANGANDCODEPAGE ends 



