bsbChart4 proc
	
	push esi
	push edi
	
	;Allocate memory
	.if pPixelData!=0
		invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pPixelData
		mov pPixelData,0
	.endif
	
	mov eax,yPos
	neg eax
	mov RowStart,eax
	sub eax,FrameRectangle.bottom
	.if sdword ptr eax>0
		mov RowStart,eax
		add eax,FrameRectangle.bottom
		add eax,FrameRectangle.bottom
		add eax,FrameRectangle.bottom
		mov RowEnd,eax
		.if eax>imageH
			mov eax,imageH
			mov RowEnd,eax
		.endif
		sub eax,RowStart
		mov PixH,eax
	.else
		mov eax,RowStart
		add eax,FrameRectangle.bottom
		add eax,FrameRectangle.bottom
		mov RowEnd,eax
		.if eax>imageH
			mov eax,imageH
			mov RowEnd,eax
		.endif
		mov PixH,eax
	.endif
	
	mov eax,xPos
	neg eax
	mov ColStart,eax
	sub eax,FrameRectangle.right
	.if sdword ptr eax>0
		mov ColStart,eax
		add eax,FrameRectangle.right
		add eax,FrameRectangle.right
		add eax,FrameRectangle.right
		mov ColEnd,eax
		.if eax>imageW
			mov eax,imageW
			mov ColEnd,eax
		.endif
		sub eax,ColStart
		mov PixW,eax
	.else
		mov eax,ColStart
		add eax,FrameRectangle.right
		add eax,FrameRectangle.right
		mov ColEnd,eax
		.if eax>imageW
			mov eax,imageW
			mov ColEnd,eax
		.endif
		mov PixW,eax
	.endif
	
	;Calculate needed memory space
	mov eax,PixW ;FrameRectangle.right ;bsbW
	mov ecx,PixH ;FrameRectangle.bottom ;bsbH
	mul ecx
	push eax ;number of pixels
	
	;Calculate padding zeros
	mov padding,0
	mov eax,PixW ;FrameRectangle.right ;bsbW
	mov ecx,4
	xor edx,edx
	div ecx
	.if edx>0
		mov padding,4
		sub padding,edx
	.endif
	mov eax,PixH ;FrameRectangle.bottom ;bsbH
	mul padding ;number of padded zeros
	
	pop ecx
	add eax,ecx
	mov memorysize,eax
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,memorysize
	mov pPixelData,eax
	
	mov esi,pBMI
	mov eax,PixW ;FrameRectangle.right ;imageW
	mov dword ptr [esi].BITMAPINFOHEADER.biWidth ,eax
	mov eax,PixH ;FrameRectangle.bottom ;imageH
	mov dword ptr [esi].BITMAPINFOHEADER.biHeight,eax
	
	;Retrieve offset of first row
	mov ecx,RowStart
	mov eax,4
	mul ecx
	mov esi,pFirstItemJmpTable
	add esi,eax
	
	.while ecx<RowEnd
		push ecx
		
		mov edi,pMemory
		mov eax,dword ptr [esi]
		bswap eax
		add edi,eax
		invoke GetRowPixels4,edi,ecx,RowStart,ColStart,ColEnd
		add esi,4
		
		pop ecx
		inc ecx
	.endw
	
	pop edi
	pop esi
    
    ret
    
bsbChart4 endp

