bsbHeader4 proc
	LOCAL index:dword
	LOCAL red:dword
	LOCAL green:dword
	LOCAL blue:dword
	LOCAL left:dword
	LOCAL top:dword
	LOCAL lat:real8
	LOCAL long:real8
	LOCAL count:dword
	LOCAL integer:dword
	LOCAL buffer[256]:byte
	LOCAL char:dword
	LOCAL cw:word
	
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	invoke GetProcessHeap
	mov hHeap,eax
	
	;Allocate memory for the bitmap header
	mov eax,sizeof BITMAPINFOHEADER
	add eax,1024 ;max sizeof colortable
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
	mov pBMI,eax
	mov dword ptr [eax].BITMAPINFOHEADER.biSize,sizeof BITMAPINFOHEADER
	mov word ptr [eax].BITMAPINFOHEADER.biPlanes,1
	mov word ptr [eax].BITMAPINFOHEADER.biBitCount,8
	
	.if pREF!=0
		invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pREF
		mov pREF,0
	.endif
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,4
	mov pREF,eax ;first dword holding number of stored refpoints
	mov dword ptr [eax],0
	
	mov edi,pMemory ;Filemapping memory
	invoke StrStr,edi,ASTR("RA=")
	invoke crt_sscanf,eax,ASTR("RA=%d,%d"),offset bsbW,offset bsbH

	invoke StrStr,edi,ASTR("IFM/")
	invoke crt_sscanf,eax,ASTR("IFM/%d"),offset ColorDepth
	
	invoke StrStr,edi,ASTR("DTM/")
	invoke crt_sscanf,eax,ASTR("DTM/%f,%f"),offset LatShift,offset LongShift
	
	mov eax,edi
@@:	invoke StrStr,eax,ASTR("RGB/")
	.if eax!=0
		push eax
		call @ColorTable
		pop eax
		add eax,4
		jmp @B
	.endif
	
	;Reference points
	mov count,0
	mov eax,edi
@@:	invoke StrStr,eax,ASTR("REF/")
	.if eax!=0
		push eax
		lea edi,buffer
		mov esi,eax
@1:		movsb
		cmp byte ptr [esi],0Dh
		je @2
		cmp byte ptr [esi],0Ah
		je @2
		jmp @1
@2:		mov byte ptr [edi],0
		call @RefTable
		pop eax
		add eax,4
		jmp @B
	.endif
	
	push bsbW
	pop imageW
	push bsbH
	pop imageH
	
	;Calculate first item in jump table
	mov esi,pMemory
	add esi,filesize
	sub esi,4
	mov eax,dword ptr [esi]
	bswap eax
	add esi,eax
	sub esi,filesize
	add esi,4
	mov pFirstItemJmpTable,esi
	
@Exit:
	pop edx
	pop edi
	pop esi
	
	ret

;===========================================================================================
@ColorTable:
	mov ecx,eax
	invoke crt_sscanf,ecx,ASTR("RGB/%d,%d,%d,%d"),addr index,addr red,addr green,addr blue
	.if eax==4
		mov eax,index
		mov esi,pBMI
		mov dword ptr [esi].BITMAPINFOHEADER.biClrUsed,eax
		mov dword ptr [esi].BITMAPINFOHEADER.biClrImportant,eax
		dec eax
		shl eax,2
		mov edx,pBMI
		add edx,sizeof BITMAPINFOHEADER
		add edx,eax
		mov eax,blue
		mov byte ptr [edx],al
		inc edx
		mov eax,green
		mov byte ptr [edx],al
		inc edx
		mov eax,red
		mov byte ptr [edx],al
		inc edx
		mov byte ptr [edx],0
	.endif
	retn
	  
@RefTable:
	mov char,","
	invoke SplitString,addr buffer,addr char,0,sizeof buffer
	.if eax==5
		push eax
		invoke GetStrArrEl,addr buffer,eax,0
		mov ecx,eax
		add ecx,4 ;REF/
		invoke StrToInt,ecx
		mov index,eax
		pop eax
		push eax
		invoke GetStrArrEl,addr buffer,eax,1
		mov ecx,eax
		invoke StrToInt,ecx
		mov left,eax
		pop eax
		push eax
		invoke GetStrArrEl,addr buffer,eax,2
		mov ecx,eax
		invoke StrToInt,ecx
		mov top,eax
		pop eax
		push eax
		invoke GetStrArrEl,addr buffer,eax,3
		mov ecx,eax
		invoke StringToFloat,ecx,addr lat
		pop eax
		invoke GetStrArrEl,addr buffer,eax,4
		mov ecx,eax
		invoke StringToFloat,ecx,addr long
		
		mov esi,pREF
		mov eax,dword ptr [esi] ;current number of ref points
		push eax
		add esi,4
		;Check if two ref point are almost equal
		xor ecx,ecx
		.while ecx<eax
			push ecx
			push eax
			
			finit
			fld lat
			mov integer,10000
			fimul integer
			fstcw cw
			movzx eax,cw
			and ax,1111001111111111b
			add ax,0000110000000000b ;truncate
			mov cw,ax
			fldcw cw
			frndint
			fidiv integer			
			
			mov eax,sizeof REF
			mul ecx
			fld dword ptr [esi+eax].REF.lat
			fimul integer
			fstcw cw
			movzx eax,cw
			and ax,1111001111111111b
			add ax,0000110000000000b ;truncate
			mov cw,ax
			fldcw cw
			frndint
			fidiv integer
			
			fsub	
			ftst
			fstsw ax
			sahf
			jne @F
				finit
				fld long
				mov integer,10000
				fimul integer
				fstcw cw
				movzx eax,cw
				and ax,1111001111111111b
				add ax,0000110000000000b ;truncate
				mov cw,ax
				fldcw cw
				frndint
				fidiv integer			
				
				mov eax,sizeof REF
				mul ecx
				fld dword ptr [esi+eax].REF.long
				fimul integer
				fstcw cw
				movzx eax,cw
				and ax,1111001111111111b
				add ax,0000110000000000b ;truncate
				mov cw,ax
				fldcw cw
				frndint
				fidiv integer
				
				fsub	
				ftst
				fstsw ax
				sahf
				je @Out
@@:			pop eax
			pop ecx
			inc ecx
		.endw
		
		mov eax,sizeof REF
		pop ecx
		inc ecx
		push ecx
		mul ecx
		add eax,4 ;To hold number of refpoints
		invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,pREF,eax
		mov pREF,eax
		pop ecx
		mov dword ptr [eax],ecx
		
		mov esi,pREF
		add esi,4
		mov eax,sizeof REF
		dec ecx
		mul ecx
		add esi,eax
		mov eax,index ;Ref point index from bsb chart
		mov dword ptr [esi].REF.index,eax
		mov eax,left
		mov dword ptr [esi].REF.left,eax
		mov eax,top
		mov dword ptr [esi].REF.top,eax
		finit
		fld lat
		fstp dword ptr [esi].REF.lat
		fld long
		fstp dword ptr [esi].REF.long
		
		retn
@Out:
		add esp,12
	.endif
	
	retn
	
bsbHeader4 endp

